//================  client.h ======================

#ifndef __client_h
#define __client_h

#include <iostream>
#include <string>
#include <vector>
#include "renting.h"
#include "car.h"

//----------

class Client
{
protected:

   std::string           name;
   std::vector<Renting*> rentings;

public:

   Client (const std::string& name);
   Client (std::istream& is);

   void save  (std::ostream& os) const; 

   std::string getName   () const {return name;}
   double      getProfit () const;
   void        print     () const;

   void     addRenting      (Renting* renting);
   int      getRentingCount () const {return rentings.size();}
   Renting* getRenting      (int i)  {return rentings[i];}
   
protected:

   void     removeRenting   (Renting* Renting);
   
   // allow Food::removeRenting to access Client::removeSelling
   friend void Car::removeRenting (Renting* renting);
};

#endif // __client_h

//=============================================================
