#include <iostream>
#include "renting.h"
#include "car.h"
#include "client.h"

using namespace std;

//---------

Renting::Renting (const Car*     car,
                  const Client*  client,
                  const string&  date,
                  int            dayCount)
                  /*double         itemPrice*/
{                  
   this->car       = car;
   this->client    = client;
   this->date      = date;
   this->dayCount  = dayCount;
   /*this->itemPrice = itemPrice*/
}

//-----------

Renting::Renting (istream&               is,
                  map<string, Car*>&     cars,
                  map<string, Client*>&  clients)
{
    string carName;
    string clientName;
    is >> carName 
       >> clientName 
       >> date 
       >> dayCount; 
       /*>> itemPrice*/
    car    = cars    [carName];
    client = clients [clientName];
    // non-const type cast to call non-const addRenting
    ((Car*)      car)->addRenting(this);
    ((Client*)client)->addRenting(this);
}

//----------

void Renting::save (std::ostream& os) const
{
   os << car   ->getName() << " "
      << client->getName() << " "
      << date              << " "
      << dayCount          << " " << endl; 
      //<< itemPrice         << " "  << endl;
}

//----------

double Renting::getProfit () const
{
   if (dayCount > 7)
      return (dayCount * (car->getPrice())) - car->getPrice();
   else
      return dayCount * (car->getPrice());
}

//---------

void Renting::print () const
{
   cout << car->getName()
        << " " << client->getName()
        << " " << date
        << " " << dayCount
        //<< " " << itemPrice
        << " pelnas=" << getProfit() 
        << endl;
}
