//==============  renting.h ==================

#ifndef __renting_h
#define __renting_h

#include <iostream>
#include <string>
#include <map>

class Car;   // forward declaration
class Client; // forward declaration

//----------

class Renting
{
protected:

   const Car*     car;
   const Client*  client;
   std::string    date;
   int            dayCount;
   /*double         itemPrice*/

public:

   Renting (const Car*          car,
            const Client*       client,
            const std::string&  date,
            int                 dayCount);
            /*double              itemPrice*/
            
   Renting (std::istream&                    is,
            std::map<std::string, Car*>&     cars,
            std::map<std::string, Client*>&  clients);
            
            
   void  save (std::ostream& os) const;         
            
   const Car*     getCar       () const {return car;}
   const Client*  getClient    () const {return client;}
   std::string    getDate      () const {return date;}
   int            getDayCount  () const {return dayCount;}
   //double         getItemPrice () const {return itemPrice;}
   double         getProfit    () const;

   void           print        () const; 
};

#endif // __renting_h

//=================================================================
